/**
* Copyright (c) 2011, Facebook, Inc.
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*   * Redistributions of source code must retain the above copyright notice,
*     this list of conditions and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*   * Neither the name Facebook nor the names of its contributors may be used to
*     endorse or promote products derived from this software without specific
*     prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
* FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
module.exports = {"ads:pe:please-install-chrome":"Please install Power Editor Chrome Extension before using.","ads:pe:chrome-install-button":"Install","ads:pe:paste-title":"Paste Progress","ads:pe:select-one-campaign-for-paste":"Please select a campaign, in Account #{act}.","ads:pe:select-one-topline-for-paste":"Please select a topline, in Account #{act}","ads:pe:parse-invalid-header":"Invalid data. Cannot parse header.","ads:pe:paste-garbage-ads-error":"Pasted text does not look like ads.","ads:pe:paste-campaign-into-ads-warning":"Pasted text contains campaign data. Ignoring.","ads:pe:paste-garbage-camps-error":"Pasted text does not look like campaign.","ads:pe:select-one-campaign-for-create":"More than one campaign selected in the left panel. Please select the one you want to create ad in.","ads:pe:dragon:line-price-na":"No price. Cannot calculate unallocated imps.","ads:pe:delivery-info-na":"N\/A (no budget)","ads:pe:dragon:campaign-budget-over-line-budget":"Total campaign budget [{camp_budget}] is over the topline budget [{line_budget}]","ads:pe:dragon:over-delivery-info":"Over [{delivered_perc}] [{completed_perc}] completed","ads:pe:dragon:under-delivery-info":"Under [{delivered_perc}] [{completed_perc}] completed","ads:pe:campaign-name-required":"Name of campaign is required","ads:pe:start-time-before-flight-time":"Start time can not be earlier than the flight start time","ads:pe:stop-time-in-the-past":"Stop time can not be in the past","ads:pe:stop-time-after-flight-time":"Stop time can not be later than the flight end time","ads:pe:creating-camp-for-ended-topline":"Can not create campaigns for an ended topline","ads:pe:validate-tokenizer-header":"Validating tokens","ads:pe:validate-tokenizer":"Please wait while your input is being validated.","ads:pe:validate-dismiss":"Dismiss","ads:pe:no-ads-to-create":"Cannot create an ad without a campaign. Create campaign first.","ads:pe:no-image-selected":"Please select an image.","cs:require-login-title":"Connect with Facebook to Continue","ads:pe:dialog-logged-out":"You have signed out of Facebook, or your session has expired. Please refresh this page and login to continue using the Powereditor.","ads:pe:dragon:contract-na":"No contract to sync.","ads:pe:parse-not-enough-rows":"Invalid data. Not enough rows.","ads:pe:import-missing-camp-update-error":"Trying to update campaign ({id}) that does not exist","ads:pe:import-ad-cannot-be-moved-error":"Ad (id: {ad_id}, name: \"{ad_name}\") cannot be moved between campaigns: from {old_id} to {new_id}","ads:pe:import-ad-cannot-be-moved-to-nowhere-error":"Ad (id: {ad_id}, name: \"{ad_name}\") cannot be moved between campaigns: from {old_id} to non-existent campaign {new_id}","ads:pe:import-missing-ad-update-error":"Trying to update ad ({id}) that does not exist","ads:pe:import-cannot-create-ad-without-camp-error":"Cannot create ad (name: \"{ad_name}\", index: {index}) without campaign id or campaign name","ads:pe:fbrequestfail":"Facebook API request failed","ads:pe:creative-type:standard":"Standard","ads:pe:creative-type:fan":"Fan","ads:pe:creative-type:rsvp":"RSVP","ads:pe:creative-type:platform-context":"Platform Context","ads:pe:creative-type:social-poll":"Social Poll","ads:pe:creative-type:comment":"Comment","ads:pe:creative-type:sample":"Sample","ads:pe:creative-type:bass-platform-story":"App Share Story","ads:pe:creative-type:bass-page-connections":"Page Like Story","ads:pe:creative-type:bass-page-checkins":"Check-In Story","ads:pe:creative-type:bass-page-posts":"Page Post Ad","ads:pe:creative-type:premium-standard":"Premium Standard","ads:pe:creative-type:premium-fan":"Premium Fan","ads:pe:creative-type:premium-event":"Premium Event","ads:pe:creative-type:premium-platform":"Premium Platform","ads:pe:creative-type:bass-app-connection":"App Used Story","ads:pe:creative-type:bass-engagement":"Page Post Like Story","ads:pe:creative-type:bass-buy-with-friend":"Buy with Friends Story","ads:pe:creative-type:bass-link-share":"Domain Story","ads:pe:creative-type:bass-questions-vote":"Questions Vote Story","ads:pe:creative-type:questions":"Questions","ads:pe:creative-type:bass-sparkbox":"Comment","ads:pe:creative-type:bass-sparkbox-comment":"Comment Story","ads:pe:creative-type:page-endorsement":"Page Endorsement","ads:pe:creative-type:query-based":"Query Based","ads:pe:creative-type:ego-house-ad":"Ego House Ad","ads:pe:creative-type:page-posts-pinned":"Page Post Ad","ads:pe:creative-type:invalid":"Invalid","ads:pe:bid-type:cpc":"CPC","ads:pe:bid-type:cpm":"CPM","ads:pe:bid-type:fcpm":"FCPM","ads:pe:bid-type:multi_premium":"Multi Premium","ads:pe:title-or-destination-required":"Title or Destination required","ads:pe:title-limit":"Title should be less than {limit} characters long","ads:pe:body-limit":"Body should be less than {limit} characters long","ads:pe:link-or-destination-required":"Link or Destination required","ads:pe:image-required":"Image required","ads:pe:unowned-content":"You do not own this Facebook content","ads:pe:countries-required":"Countries required","ads:pe:revert-nothing-selected":"Nothing to revert.","ads:pe:no-ads-to-duplicate":"Please select ads to duplicate.","ads:pe:no-camps-to-duplicate":"Please select camps to duplicate.","ads:pe:select-line-number-title":"Select target line number","ads:pe:select-line-number-text":"Please select the line for the campaign.","sh:ok-button":"Okay","sh:cancel-button":"Cancel","ads:pe:import-nonts-error":"Please select file with tab separated data.","ads:pe:import-nozip-error":"Please select zip file with images.","ads:pe:import-zip-upload-message":"Sending zip file to the server to unpack.","ads:pe:import-parsets-message":"Parsing tab separated text - {percent}.","ads:pe:import-nocampaigns-error":"Data does not contain campaigns info.","ads:pe:import-create-camps-message":"Creating campaigns - {percent}.","ads:pe:import-create-ads-message":"Creating ads - {percent}.","ads:pe:import-finished-message":"Finished importing","ads:pe:import-title":"Importing","ads:pe:account-status:active":"Active","ads:pe:account-status:disabled":"Disabled","ads:pe:account-status:unsettled":"Unsettled","ads:pe:account-status:pending-risk-review":"Pending Risk Review","ads:pe:account-status:pending-closure":"Pending Closure","ads:pe:account-status:closed":"Closed","ads:pe:account-status:invalid":"Invalid","ads:pe:pit-placeholder":"Enter an interest","ads:pe:pit-suggestions":"Suggested Likes & Interests","ads:pe:pit-refresh":"Refresh Suggested Interests","ads:pe:no-objectid-selected":"Please enter at least one object id.","ads:pe:Campaigns":"Campaigns","ads:pe:upload_status_message_with_range":"{category}: {range_string} {msg}","ads:pe:upload_status_message":"{category}: {msg}","ads:pe:starting_to_upload_n_campaigns":"Starting to upload {n} campaigns","ads:pe:error_campaigns_in_account_must_belong_to_line":"Campaigns of {account_name} must belong to a line.  Please try to select a line for the campaign","ads:pe:retrying_n_campaigns":"Retrying {n} campaigns","ads:pe:upload_range":"{from} - {to}","ads:pe:retry_prefix":"RETRY {n} - {msg}","ads:pe:Uploading":"Uploading","ads:pe:processing_result_for_thing":"{thing}: processing result","ads:pe:upload-fail-create-camp":"Failed to create campaign \"{name}\": {message}","ads:pe:upload-fail-download-updates-camp":"Failed to download campaign updates for \"{name}\"","ads:pe:upload-fail-update-camp":"Failed to update campaign \"{name}\": {message}","ads:pe:Ads":"Ads","ads:pe:fetching_ads_to_upload":"fetching ads to upload","ads:pe:Done":"Done","ads:pe:retrying_n_ads":"Retrying {n} ads","ads:pe:starting_to_upload_n_ads":"Starting to upload {n} ads","ads:pe:upload-fail-create-ad":"Failed to create ad \"{name}\": {message}","ads:pe:upload-fail-update-ad":"Failed to update ad \"{name}\": {message}","ads:pe:will_retry_suffix":"{msg} - will retry","ads:pe:redownload_failed":"Redownload failed","ads:pe:starting_to_upload_n_images":"Starting to upload {n} images","ads:pe:retrying_n_images":"Retrying {n} images","ads:pe:upload-fail-image":"Failed to update ad \"{name}\": {message}","ads:pe:generic-invalid-type":"Not support type.","ads:pe:no-account-selected":"Please select at least one account.","ads:pe:bct-needs-update":"Broad Category Targeting data is out of date. Updating."};
